
c = [];
pi = [];
n = size(X,1); % n = number of data points
q = [];
maxiter = 50; % Set number of iterations

% Initialize parameters and mixture distribution
mn = min(X); mx = max(X);

Mean = mean(X);
Variance = cov(X);

%Randomly initialize means and covariance matrix
for j=1:K
    mu(j,:) = [randn(1,1)*sqrt(Variance(1,1)) + Mean(1), randn(1,1)*sqrt(Variance(2,2)) + Mean(2) ]
    Sigma(:,:,j) = [[rand(1,1)*Variance(1,1),0];[0,rand(1,1)*sqrt(Variance(2,2))]];
    pi(j) = 1/K;
end

% Initialize the gaussian mixture model distribution for plotting the
% ellipse

gmm = gmdistribution(mu,Sigma,pi);

% plot points and ellipses
scatter(X(:,1),X(:,2));

hold on;
pause;
for j = 1:K
    scatter(mu(j,1),mu(j,2),'*');
end
h = ezcontour(@(x,y)pdf(gmm,[x y]), [mn(1) mx(1) mn(2) mx(2)]);
pause;
hold off;

% Start Algorithm iterations
for m = 1:maxiter

    % Based on current parameters, reassign clusters
    for t = 1:n
        for k = 1:K
            l =  (X(t,:)- mu(k,:))*pinv(Sigma(:,:,k))*(X(t,:)- mu(k,:))' ;
            q(t,k) = det(Sigma(:,:,k))^(-0.5) * exp(-l/2)*pi(k);
        end
        q(t,:) = q(t,:)/sum(q(t,:));
        
        
    end
    for t = 1:n
        [a,b] = max(q(t,:));
        c(t) = b(1);
    end
    
    % plot
   scatter(X(find(c==1),1),X(find(c==1),2),'b');
   hold on;
    scatter(X(find(c==2),1),X(find(c==2),2),'r');
    scatter(X(find(c==3),1),X(find(c==3),2),'g');
   
    
    % Based on current cluster assignment recompute parameters
    for k = 1:K
        mu(k,:)  = q(:,k)'*X/sum(q(:,k));
        A = zeros(2,2);
        for t = 1:n
            A = A + q(t,k)*(X(t,:) - mu(k,:))'*(X(t,:) - mu(k,:))/sum(q(:,k));
        end
        Sigma(:,:,k)= A;
        pi(k) = sum(q(:,k))/n;
    end
    pi = pi/sum(pi)
    Sigma
    mu
    
    % plot
    gmm = gmdistribution(mu,Sigma,pi);
for j = 1:K
    scatter(mu(j,1),mu(j,2),'*');
end

h = ezcontour(@(x,y)pdf(gmm,[x y]), [mn(1) mx(1) mn(2) mx(2)]);
pause;
hold off;
end
